package pl.info.kardas.passman.ejb.test;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Properties;

import javax.ejb.EJBAccessException;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import pl.info.kardas.passman.ejb.PassManBeanRemote;
import pl.info.kardas.passman.jpa.PassManObject;
import pl.info.kardas.passman.jpa.PassManObjectAccessLevels;
import pl.info.kardas.passman.jpa.PassManObjectAdmin;
import pl.info.kardas.passman.jpa.PassManObjectAdminGroup;
import pl.info.kardas.passman.jpa.PassManObjectGroup;
import pl.info.kardas.passman.jpa.PassManObjectAdminRights;
import pl.info.kardas.passman.jpa.PassManObjectAdminGroupRights;
import pl.info.kardas.passman.jpa.PassManObjectType;
import pl.info.kardas.passman.jpa.PassManObjectUserPassword;

import junit.framework.TestCase;

public class Test extends TestCase {
    private Properties env = new Properties();
    private InitialContext ctx;
    private PassManBeanRemote passManBean;
    
    private void init() throws NamingException{
    	env.setProperty(Context.PROVIDER_URL, "jnp://localhost:1099");
	    env.setProperty(Context.SECURITY_PRINCIPAL, "admin");
	    env.setProperty(Context.SECURITY_CREDENTIALS, "1admin");
	    //env.setProperty(Context.SECURITY_PRINCIPAL, "user");
	    //env.setProperty(Context.SECURITY_CREDENTIALS, "1user");
	    env.setProperty(Context.INITIAL_CONTEXT_FACTORY, "org.jboss.security.jndi.JndiLoginInitialContextFactory");
		ctx = new InitialContext(env);
		passManBean = (PassManBeanRemote) ctx.lookup("PassMan/PassManBean/remote");
    }
    
    
	public final void testLogin() {
	    try {
	    	init();
			System.out.println("Is loged in: " + passManBean.login());
		} catch (NamingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (EJBAccessException e){
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public final void testLogout() {
		fail("Not yet implemented"); // TODO
	}

	public final void testGetPassManObject() {
		try {
			init();
			List<PassManObject> o = passManBean.getPassManObject(null, null);
			System.out.println(o);
		} catch (NamingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	public final void testGetPassManObjectGroups() {
		try {
			init();
			List<PassManObjectGroup> o = passManBean.getPassManObjectGroups(null, null);
			System.out.println(o);
		} catch (NamingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	public final void testGetPassManObjectUserPassword() {
		try {
			init();
			List<PassManObjectUserPassword> o = passManBean.getPassManObjectUserPassword(null, null);
			System.out.println(o);
		} catch (NamingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public final void testAddPassManObjectAdmin() {
		try {
			init();
			PassManObjectAdmin objectAdmin = new PassManObjectAdmin();
			
			objectAdmin.setLogin("admin");
			objectAdmin.setName("Administrator");
			
			//objectAdmin.setLogin("user");
			//objectAdmin.setName("User");

			List<PassManObjectAdminGroup> list = passManBean.getPassManObjectAdminGroups(null, null);
			System.out.println("Lista: " + list.toString());
			
			objectAdmin.setGroups(list);
			
			passManBean.addPassManObjectAdmin(objectAdmin);
			
		} catch (NamingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	public final void testAddPassManObjectAdminGroup() {
		try {
			init();
			PassManObjectAdminGroup group = new PassManObjectAdminGroup();
			group.setName("Unix Admins");
			group.setComment("Admini Unix");
			passManBean.addPassManObjectAdminGroup(group);
		} catch (NamingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public final void testAddPassManObject() {
		try {
			init();
			PassManObject passManObject = new PassManObject();
			passManObject.setComment("Serwerek");
			passManObject.setName("Nazwa");
			List<PassManObjectAdminGroup> adminGroups = passManBean.getPassManObjectAdminGroups(null, null);
			List<PassManObjectAdmin> admins = passManBean.getPassManObjectAdmins(null, null);
			List<PassManObjectGroup> serverGroups = passManBean.getPassManObjectGroups(null, null);
 			
			List<PassManObjectAdminGroupRights> adminGroupRights = new ArrayList<PassManObjectAdminGroupRights>();
			
			List<PassManObjectAdminRights> adminRights = new ArrayList<PassManObjectAdminRights>();
			
			Iterator<PassManObjectAdminGroup> adminGroupItr = adminGroups.iterator();
			
			while(adminGroupItr.hasNext()){
				PassManObjectAdminGroup o = (PassManObjectAdminGroup) adminGroupItr.next();
				System.out.println("Grupa: " + o.getName());
				adminGroupRights.add(new PassManObjectAdminGroupRights(o, PassManObjectAccessLevels.NO_ACCESS));
			}
			
			Iterator<PassManObjectAdmin> adminRightsItr = admins.iterator();
			while(adminRightsItr.hasNext()){
				PassManObjectAdmin o = (PassManObjectAdmin) adminRightsItr.next();
				System.out.println("Admin: " + o.getLogin());
				adminRights.add(new PassManObjectAdminRights(o, PassManObjectAccessLevels.READ_ONLY));
			}
			
			passManObject.setAdminRights(adminRights);
			passManObject.setAdminGroupRights(adminGroupRights);
			passManObject.setGroups(serverGroups);
			passManObject.setType(passManBean.getPassManObjectTypes(null, null).get(0));
			passManObject.setHashKey("123");
			//passManObject.setId(1);
			
			passManBean.addPassManObject(passManObject);
			
		} catch (NamingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
	public final void testAddPassManObjectGroup() {
		try {
			init();
			PassManObjectGroup passManObjetGroup = new PassManObjectGroup();
			passManObjetGroup.setName("Linux Oracle Machines");
			passManObjetGroup.setComment("Komentarz");
			
			passManBean.addPassManObjectGroup(passManObjetGroup);
			
		} catch (NamingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	public final void testAddPassManObjectType() {
		try {
			init();
			PassManObjectType passManObjectType = new PassManObjectType();
			passManObjectType.setName("Unix");
			passManObjectType.setComment("Serwery unix i linux");

			passManBean.addPassManObjectType(passManObjectType);
			
		} catch (NamingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	public final void testAddPassManObjectUserPassword() {
		try {
			init();
			
			List<PassManObject> o = passManBean.getPassManObject(null, null);
			PassManObjectUserPassword userPassword = new PassManObjectUserPassword();
			
			List<PassManObjectAdminGroup> adminGroups = passManBean.getPassManObjectAdminGroups(null, null);
			List<PassManObjectAdmin> admins = passManBean.getPassManObjectAdmins(null, null);

			List<PassManObjectAdminGroupRights> adminGroupRights = new ArrayList<PassManObjectAdminGroupRights>();
			List<PassManObjectAdminRights> adminRights = new ArrayList<PassManObjectAdminRights>();
			
			Iterator<PassManObjectAdminGroup> adminGroupItr = adminGroups.iterator();
			
			while(adminGroupItr.hasNext()){
				PassManObjectAdminGroup objectAdminGroup = (PassManObjectAdminGroup) adminGroupItr.next();
				System.out.println("Grupa: " + objectAdminGroup.getName());
				adminGroupRights.add(new PassManObjectAdminGroupRights(objectAdminGroup, PassManObjectAccessLevels.NO_ACCESS));
			}
			
			Iterator<PassManObjectAdmin> adminRightsItr = admins.iterator();
			while(adminRightsItr.hasNext()){
				PassManObjectAdmin objectAdmin = (PassManObjectAdmin) adminRightsItr.next();
				System.out.println("Admin: " + objectAdmin.getLogin());
				adminRights.add(new PassManObjectAdminRights(objectAdmin, PassManObjectAccessLevels.READ_ONLY));
			}

			userPassword.setObject(o.get(0));
			
			userPassword.setComment("Testowe zestaw user/pass");
			userPassword.setName("Testowy zestaw user/pass");
			userPassword.setPassword("password");
			userPassword.setUser("user");

			userPassword.setAdminRights(adminRights);
			userPassword.setAdminGroupRights(adminGroupRights);

			
			passManBean.addPassManObjectUserPassword(userPassword);
			
		} catch (NamingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

}
