drop database passman;
create database passman;
use passman;

    create table PassManObject (
        id integer not null auto_increment unique,
        comment varchar(255),
        hashKey varchar(255),
        name varchar(255),
        type_name varchar(255),
        primary key (id)
    ) ENGINE=InnoDB;

    create table PassManObjectAdmin (
        login varchar(255) not null unique,
        lastName varchar(255),
        name varchar(255),
        primary key (login)
    ) ENGINE=InnoDB;

    create table PassManObjectAdminGroup (
        name varchar(255) not null unique,
        comment varchar(255),
        primary key (name)
    ) ENGINE=InnoDB;

    create table PassManObjectAdminGroup_PassManObjectAdmin (
        PassManObjectAdminGroup_name varchar(255) not null,
        admins_login varchar(255) not null
    ) ENGINE=InnoDB;

    create table PassManObjectAdminRights (
        id integer not null auto_increment unique,
        accessLevel varchar(255),
        admin_login varchar(255),
        primary key (id)
    ) ENGINE=InnoDB;

    create table PassManObjectAdmin_PassManObjectAdminGroup (
        PassManObjectAdmin_login varchar(255) not null,
        groups_name varchar(255) not null
    ) ENGINE=InnoDB;

    create table PassManObjectGroup (
        name varchar(255) not null unique,
        comment varchar(255),
        primary key (name)
    ) ENGINE=InnoDB;

    create table PassManObjectRights (
        id integer not null auto_increment unique,
        accessLevel varchar(255),
        group_name varchar(255),
        primary key (id)
    ) ENGINE=InnoDB;

    create table PassManObjectType (
        name varchar(255) not null unique,
        comment varchar(255),
        primary key (name)
    ) ENGINE=InnoDB;

    create table PassManObjectUserPassword (
        id integer not null auto_increment unique,
        comment varchar(255),
        encryptedPassword varchar(255),
        encryptedUser varchar(255),
        name varchar(255),
        object_id integer,
        primary key (id)
    ) ENGINE=InnoDB;

    create table PassManObjectUserPassword_PassManObjectAdminRights (
        PassManObjectUserPassword_id integer not null,
        adminRights_id integer not null
    ) ENGINE=InnoDB;

    create table PassManObjectUserPassword_PassManObjectRights (
        PassManObjectUserPassword_id integer not null,
        adminGroupRights_id integer not null
    ) ENGINE=InnoDB;

    create table PassManObject_PassManObjectAdminRights (
        PassManObject_id integer not null,
        adminRights_id integer not null
    ) ENGINE=InnoDB;

    create table PassManObject_PassManObjectGroup (
        PassManObject_id integer not null,
        groups_name varchar(255) not null
    ) ENGINE=InnoDB;

    create table PassManObject_PassManObjectRights (
        PassManObject_id integer not null,
        adminGroupRights_id integer not null
    ) ENGINE=InnoDB;

    create table PassManObject_PassManObjectUserPassword (
        PassManObject_id integer not null,
        userPasswords_id integer not null,
        unique (userPasswords_id)
    ) ENGINE=InnoDB;

    alter table PassManObject 
        add index FK4F363808CD7D0914 (type_name), 
        add constraint FK4F363808CD7D0914 
        foreign key (type_name) 
        references PassManObjectType (name);

    alter table PassManObjectAdminGroup_PassManObjectAdmin 
        add index FKA59A092E172A3593 (admins_login), 
        add constraint FKA59A092E172A3593 
        foreign key (admins_login) 
        references PassManObjectAdmin (login);

    alter table PassManObjectAdminGroup_PassManObjectAdmin 
        add index FKA59A092EEE7FF60C (PassManObjectAdminGroup_name), 
        add constraint FKA59A092EEE7FF60C 
        foreign key (PassManObjectAdminGroup_name) 
        references PassManObjectAdminGroup (name);

    alter table PassManObjectAdminRights 
        add index FK90D714DE18C42D9E (admin_login), 
        add constraint FK90D714DE18C42D9E 
        foreign key (admin_login) 
        references PassManObjectAdmin (login);

    alter table PassManObjectAdmin_PassManObjectAdminGroup 
        add index FKA9DEC680EF308876 (PassManObjectAdmin_login), 
        add constraint FKA9DEC680EF308876 
        foreign key (PassManObjectAdmin_login) 
        references PassManObjectAdmin (login);

    alter table PassManObjectAdmin_PassManObjectAdminGroup 
        add index FKA9DEC6804D804470 (groups_name), 
        add constraint FKA9DEC6804D804470 
        foreign key (groups_name) 
        references PassManObjectAdminGroup (name);

    alter table PassManObjectRights 
        add index FK24C37FFF373B5AA5 (group_name), 
        add constraint FK24C37FFF373B5AA5 
        foreign key (group_name) 
        references PassManObjectAdminGroup (name);

    alter table PassManObjectUserPassword 
        add index FK7049CFAEB2E7B465 (object_id), 
        add constraint FK7049CFAEB2E7B465 
        foreign key (object_id) 
        references PassManObject (id);

    alter table PassManObjectUserPassword_PassManObjectAdminRights 
        add index FKDE87384F33D0DF70 (adminRights_id), 
        add constraint FKDE87384F33D0DF70 
        foreign key (adminRights_id) 
        references PassManObjectAdminRights (id);

    alter table PassManObjectUserPassword_PassManObjectAdminRights 
        add index FKDE87384FAA72DA5C (PassManObjectUserPassword_id), 
        add constraint FKDE87384FAA72DA5C 
        foreign key (PassManObjectUserPassword_id) 
        references PassManObjectUserPassword (id);

    alter table PassManObjectUserPassword_PassManObjectRights 
        add index FKCA1539EED1A32AC4 (adminGroupRights_id), 
        add constraint FKCA1539EED1A32AC4 
        foreign key (adminGroupRights_id) 
        references PassManObjectRights (id);

    alter table PassManObjectUserPassword_PassManObjectRights 
        add index FKCA1539EEAA72DA5C (PassManObjectUserPassword_id), 
        add constraint FKCA1539EEAA72DA5C 
        foreign key (PassManObjectUserPassword_id) 
        references PassManObjectUserPassword (id);

    alter table PassManObject_PassManObjectAdminRights 
        add index FK5147093533D0DF70 (adminRights_id), 
        add constraint FK5147093533D0DF70 
        foreign key (adminRights_id) 
        references PassManObjectAdminRights (id);

    alter table PassManObject_PassManObjectAdminRights 
        add index FK51470935B33346DC (PassManObject_id), 
        add constraint FK51470935B33346DC 
        foreign key (PassManObject_id) 
        references PassManObject (id);

    alter table PassManObject_PassManObjectGroup 
        add index FKE2E954EEB33346DC (PassManObject_id), 
        add constraint FKE2E954EEB33346DC 
        foreign key (PassManObject_id) 
        references PassManObject (id);

    alter table PassManObject_PassManObjectGroup 
        add index FKE2E954EE84CC206B (groups_name), 
        add constraint FKE2E954EE84CC206B 
        foreign key (groups_name) 
        references PassManObjectGroup (name);

    alter table PassManObject_PassManObjectRights 
        add index FK8C83F148D1A32AC4 (adminGroupRights_id), 
        add constraint FK8C83F148D1A32AC4 
        foreign key (adminGroupRights_id) 
        references PassManObjectRights (id);

    alter table PassManObject_PassManObjectRights 
        add index FK8C83F148B33346DC (PassManObject_id), 
        add constraint FK8C83F148B33346DC 
        foreign key (PassManObject_id) 
        references PassManObject (id);

    alter table PassManObject_PassManObjectUserPassword 
        add index FKBDD86637B33346DC (PassManObject_id), 
        add constraint FKBDD86637B33346DC 
        foreign key (PassManObject_id) 
        references PassManObject (id);

    alter table PassManObject_PassManObjectUserPassword 
        add index FKBDD86637716CA7BD (userPasswords_id), 
        add constraint FKBDD86637716CA7BD 
        foreign key (userPasswords_id) 
        references PassManObjectUserPassword (id);
