package pl.info.kardas.passman.jpa;

import java.io.Serializable;
import java.lang.String;
import java.util.List;

import javax.persistence.*;

/**
 * Entity implementation class for Entity: ObjectAdmin
 * ObjectAdmin in PassMan is a person that manages users and passwords for object and also manages object
 */
@Entity
@NamedQuery(name = "ListAllAdmins", query = "select admins from PassManObjectAdmin as admins")
@Table(name = "PassManObjectAdmin")
public class PassManObjectAdmin implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@Column(name = "login", nullable = false, unique = true)
	private String login;

	@Column(name = "name")
	private String name;

	@Column(name = "lastName")
	private String lastName;

	@ManyToMany(targetEntity = pl.info.kardas.passman.jpa.PassManObjectAdminGroup.class)
	private List<PassManObjectAdminGroup> groups;

	public PassManObjectAdmin() {
		super();
	}   
	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}   
	public String getLogin() {
		return this.login;
	}

	public void setLogin(String login) {
		this.login = login;
	}   
	public String getLastName() {
		return this.lastName;
	}

	public void setLastName(String lastName) {
		this.lastName = lastName;
	}   
	public List<PassManObjectAdminGroup> getGroups() {
		return this.groups;
	}

	public void setGroups(List<PassManObjectAdminGroup> groups) {
		this.groups = groups;
	}
   
}
