package pl.info.kardas.passman.jpa;

import java.io.Serializable;
import java.lang.String;
import java.util.List;

import javax.persistence.*;

/**
 * Entity implementation class for Entity: ObjectAdminGroup
 * ObjectAdminGroup in PassMan means a group of admins for examle - group of dba admins, unix admins
 * It simplifies the right process 
 */
//TODO: Unique keys for name field
@Entity
@Table(name = "PassManObjectAdminGroup")
@NamedQuery(name = "ListAllAdminGroups", query = "select groups from PassManObjectAdminGroup as groups")
public class PassManObjectAdminGroup implements Serializable {

	private static final long serialVersionUID = 1L;
	
	@Id
	@Column(name = "name", unique = true, nullable = false)
	private String name;
		
	@Column(name = "comment")
	private String comment;

	@ManyToMany(targetEntity = pl.info.kardas.passman.jpa.PassManObjectAdmin.class)
	private List<PassManObjectAdmin> admins;
	
	public PassManObjectAdminGroup() {
		super();
	}   
	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}   
	public String getComment() {
		return this.comment;
	}

	public void setComment(String comment) {
		this.comment = comment;
	}   
	public List<PassManObjectAdmin> getAdmins() {
		return this.admins;
	}

	public void setAdmins(List<PassManObjectAdmin> admins) {
		this.admins = admins;
	}
   
}
