package pl.info.kardas.passman.jpa;

import static javax.persistence.GenerationType.IDENTITY;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import static javax.persistence.EnumType.STRING;
import javax.persistence.ManyToOne;

@Entity
@Table(name = "PassManObjectAdminRights")
public class PassManObjectAdminRights implements Serializable {
	
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = IDENTITY)
	@Column(name="id", unique = true, nullable = true)
	private Integer id;
	
	@Enumerated(value = STRING)
	@Column(name = "accessLevel")
	private PassManObjectAccessLevels accessLevel = PassManObjectAccessLevels.NO_ACCESS;

	@ManyToOne(targetEntity = pl.info.kardas.passman.jpa.PassManObjectAdmin.class)
	private PassManObjectAdmin admin;
	
	public PassManObjectAdminRights() {
	}
	
	public PassManObjectAdminRights(PassManObjectAdmin admin, PassManObjectAccessLevels accessLevel){
		this.admin = admin;
		this.accessLevel = accessLevel;
	}
	
	public void setId(Integer id) {
		this.id = id;
	}

	public Integer getId() {
		return id;
	}

	public void setAccessLevel(PassManObjectAccessLevels accessLevel) {
		this.accessLevel = accessLevel;
	}

	public PassManObjectAccessLevels getAccessLevel() {
		return accessLevel;
	}

	public void setAdmin(PassManObjectAdmin admin) {
		this.admin = admin;
	}

	public PassManObjectAdmin getAdmin() {
		return admin;
	}

//	public void setName(String name) {
//		this.name = name;
//	}

//	public String getName() {
//		return name;
//	}
}
