package pl.info.kardas.passman.jpa;

import java.io.Serializable;
import java.lang.String;
import javax.persistence.*;


/**
 * Entity implementation class for Entity: ObjectGroup
 * ObjectGroup in PassMan means a group of objects that corresponds to life like EShop corresponds to some apache servers, some db servers
 */
@Entity
@Table(name = "PassManObjectGroup")
@NamedQuery(name = "ListAllObjectGroups", query = "select groups from PassManObjectGroup as groups")
public class PassManObjectGroup implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@Column(name = "name", unique = true, nullable = false)
	private String name;
	
	@Column(name = "comment")
	private String comment;

	public PassManObjectGroup() {
		super();
	}   
	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}   
	public String getComment() {
		return this.comment;
	}

	public void setComment(String comment) {
		this.comment = comment;
	}
   
}
