package pl.info.kardas.passman.jpa;

import java.io.Serializable;
import java.lang.String;
import javax.persistence.*;

/**
 * Entity implementation class for Entity: ObjectType
 * ObjectType in PassMan means a group of objects that has the same type for example: unix servers, windows servers etc.
 */
@Entity
@NamedQuery(name = "ListAllObjectTypes", query = "select types from PassManObjectType as types")
@Table(name = "PassManObjectType")
public class PassManObjectType implements Serializable {

	private static final long serialVersionUID = 1L;
	
	@Id
	@Column(name = "name", unique = true, nullable = false)
	private String name;
	
	@Column(name = "comment")
	private String comment;
	
	public PassManObjectType() {
		super();
	}   
	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}   
	public String getComment() {
		return this.comment;
	}

	public void setComment(String comment) {
		this.comment = comment;
	}
   
}
